package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.apache.bcel.generic.BranchInstruction;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.InstructionHandle;
import org.apache.bcel.generic.ReturnaddressType;
import org.apache.bcel.generic.StackProducer;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.TypedInstruction;
import org.apache.bcel.generic.UnconditionalBranch;

public abstract class JsrInstruction extends BranchInstruction implements UnconditionalBranch, TypedInstruction, StackProducer {
  JsrInstruction() {}
  
  JsrInstruction(short opcode, InstructionHandle target) {
    super(opcode, target);
  }
  
  public Type getType(ConstantPoolGen cp) {
    return new ReturnaddressType(physicalSuccessor());
  }
  
  public InstructionHandle physicalSuccessor() {
    InstructionHandle ih = getTarget();
    while (ih.getPrev() != null)
      ih = ih.getPrev(); 
    while (ih.getInstruction() != this)
      ih = ih.getNext(); 
    InstructionHandle toThis = ih;
    while (ih != null) {
      ih = ih.getNext();
      if (ih != null && ih.getInstruction() == this)
        throw new IllegalStateException("physicalSuccessor() called on a shared JsrInstruction."); 
    } 
    return toThis.getNext();
  }
}
